Package com.xebialabs.xlrelease.domain

## Class ParallelGroup

- java.lang.Object
- - com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem
  - - com.xebialabs.xlrelease.domain.PlanItem
    - - com.xebialabs.xlrelease.domain.Task
      - - com.xebialabs.xlrelease.domain.TaskGroup
        - - com.xebialabs.xlrelease.domain.ParallelGroup

- All Implemented Interfaces:
    `ConfigurationItem`, `Lockable`, `TaskContainer`, `VisitableItem`, `java.io.Serializable`, `java.lang.Comparable<BaseConfigurationItem>`

      @Metadata(label="Parallel Group",
                versioned=false)
      public class ParallelGroup
      extends TaskGroup

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected java.util.Set<Link>` | `links` |

    - ### Fields inherited from class com.xebialabs.xlrelease.domain.TaskGroup

      `tasks`

    - ### Fields inherited from class com.xebialabs.xlrelease.domain.Task

      `CATEGORY_INPUT, CATEGORY_OUTPUT, delayDuringBlackout, DUE_SOON_THRESHOLD, executionId, failureHandler, failuresCount, hasBeenDelayed, hasBeenFlagged, IS_AUTOMATED_AND_IN_PROGRESS, maxCommentSize, originalScheduledStartDate, postponedDueToBlackout, postponedUntilEnvironmentsAreReserved, precondition, status, tags, taskFailureHandlerEnabled, taskRecoverOp, team, UNKNOWN_TASK_TYPE, variableMapping, waitForScheduledStartDate`

    - ### Fields inherited from class com.xebialabs.xlrelease.domain.PlanItem

      `BY_TITLE, description, dueDate, endDate, flagComment, flagStatus, overdueNotified, owner, plannedDuration, scheduledStartDate, startDate, title`

    - ### Fields inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

      `id, syntheticProperties, type`

    - ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

      `SYNTHETIC_PROPERTIES_FIELD, TYPE_FIELD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ParallelGroup()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Link` | `findLink​(java.lang.String linkId)` |
    `java.util.Set<Link>` | `getLinks()` |
    `java.util.List<Link>` | `getLinksOf​(Task task)` |
    `java.util.List<Task>` | `getPlanningSourceOf​(Task task)` |
    `java.util.List<Task>` | `getPlanningTargetsOf​(Task task)` |
    `void` | `setLinks​(java.util.Set<Link> links)` |
    `void` | `setTasks​(java.util.List<Task> tasks)` |
    `protected Changes` | `startSubTasksIfPreconditionNotInProgress()` |
    `protected Changes` | `tryToStartPlanningTargets​(Task task)` |

    - ### Methods inherited from class com.xebialabs.xlrelease.domain.TaskGroup

      `abort, accept, addTask, deleteTask, fail, fail, fail, getAllTasks, getChildren, getDelayedCount, getFlaggedCount, getTask, getTasks, getUnboundRequiredVariables, isFailureHandlerEnabled, isSkippableOrRetriable, isUpdatable, markAsDone, resetToPlanned, retry, startNow, updateGroupStatusIfNecessary`

    - ### Methods inherited from class com.xebialabs.xlrelease.domain.Task

      `addWatcher, applyDefaults, canBeBackup, canScheduleTaskStart, canStartNow, checkDatesValidity, clearComments, delayDuringBlackoutHasChanged, deleteAttachment, execute, fail, failureHandlerHasChanged, findComment, freezeVariables, freezeVariablesInCustomFields, fromType, fromType, generateExecutionId, getAbortScript, getAttachments, getCiUid, getComments, getConfigurationUri, getContainer, getDisplayPath, getElapsedDurationFraction, getExecutionId, getFacets, getFailureHandler, getFailuresCount, getInputVariables, getMaxCommentSize, getOriginalScheduledStartDate, getPhase, getPrecondition, getReferencedVariables, getRelease, getReleaseOwner, getReleaseUid, getStatus, getTags, getTaskRecoverOp, getTaskType, getTeam, getUrl, getVariableMapping, getVariableUsages, getWatchers, hasAbortScript, hasBeenDelayed, hasBeenFlagged, hasBeenStarted, hasFailureHandlerScript, hasTaskRecoverOp, hasTeam, hasVariableMapping, isAborted, isAbortScriptInProgress, isActive, isAssignedTo, isAutomated, isCheckAttributes, isCompletedInAdvance, isDefaultTaskType, isDefunct, isDelayDuringBlackout, isDone, isDoneInAdvance, isDueSoon, isDueSoonNotified, isFacetInProgress, isFailed, isFailing, isFailureHandlerInProgress, isGate, isInProgress, isLocked, isMovable, isNotYetReached, isParallelGroup, isPending, isPlanned, isPostponedDueToBlackout, isPostponedUntilEnvironmentsAreReserved, isPreconditionEnabled, isPreconditionInProgress, isSkipped, isSkippedInAdvance, isStillExecutingScript, isSupportedInWorkflow, isTaskFailureHandlerEnabled, isTaskGroup, isWaitForScheduledStartDate, isWaitingForInput, lock, ownerHasBeenReassigned, postponeUntilEnvironmentsAreReserved, preconditionHasChanged, removeWatcher, reopen, replaceTask, setAttachments, setCheckAttributes, setCiUid, setConfigurationUri, setContainer, setDelayDuringBlackout, setDueSoonNotified, setExecutionId, setFacets, setFailureHandler, setFailuresCount, setFlagStatus, setHasBeenDelayed, setHasBeenFlagged, setLocked, setMaxCommentSize, setOriginalScheduledStartDate, setPostponedDueToBlackout, setPostponedUntilEnvironmentsAreReserved, setPrecondition, setReleaseUid, setScheduledStartDate, setStatus, setSupportedInWorkflow, setTags, setTaskFailureHandlerEnabled, setTaskRecoverOp, setTeam, setVariableMapping, setWaitForScheduledStartDate, setWatchers, shouldFacetBeChecked, shouldFreezeVariableMapping, shouldNotifyDueSoon, shouldPreconditionBeChecked, start, startPending, startWithInput, teamHasBeenReassigned, unlock, updateComment`

    - ### Methods inherited from class com.xebialabs.xlrelease.domain.PlanItem

      `calculateDueDate, checkDatesValidity, getActualDuration, getComputedPlannedDuration, getDescription, getDueDate, getEndDate, getEndOrDueDate, getFlagComment, getFlagStatus, getOrCalculateDueDate, getOwner, getPlannedDuration, getScheduledStartDate, getStartDate, getStartOrScheduledDate, getTitle, hasDueDate, hasEndDate, hasEndOrDueDate, hasOwner, hasOwner, hasPlannedDuration, hasScheduledStartDate, hasStartDate, hasStartOrScheduledDate, hasTitle, hasTitle, hasValidStartDates, isFlagged, isOverdue, isOverdueNotified, isTitleContaining, moveChildren, setDates, setDescription, setDueDate, setEndDate, setFlagComment, setOverdueNotified, setOwner, setPlannedDuration, setStartAndEndDatesIfEmpty, setStartDate, setTitle, shouldNotifyOverdue, updateDates, updateDuration`

    - ### Methods inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

      `compareTo, equals, get$ciAttributes, get$directoryReference, get$externalProperties, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$token, get$validationMessages, getId, getName, getProperty, getPropertyDescriptor, getType, hashCode, hasProperty, set$ciAttributes, set$directoryReference, set$externalProperties, set$internalId, set$referenceId, set$securedCi, set$securedDirectoryReference, set$token, set$validationMessages, setId, setProperty, setType, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

      `get$directoryReference, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$validationMessages, getId, getName, getProperty, getType, hasProperty, setId, setProperty`

    - ### Methods inherited from interface com.xebialabs.xlrelease.domain.TaskContainer

      `getTitle, isLocked, replaceTask, replaceTask`

- - ### Field Detail

    - #### links

          @Property(asContainment=true,
                    required=false)
          protected java.util.Set<Link> links

  - ### Constructor Detail

    - #### ParallelGroup

          public ParallelGroup()

  - ### Method Detail

    - #### setTasks

          public void setTasks​(java.util.List<Task> tasks)

      Specified by:
        `setTasks` in interface `TaskContainer`
      Specified by:
        `setTasks` in class `TaskGroup`

    - #### getLinks

          public java.util.Set<Link> getLinks()

    - #### setLinks

          public void setLinks​(java.util.Set<Link> links)

    - #### getLinksOf

          public java.util.List<Link> getLinksOf​(Task task)

    - #### getPlanningTargetsOf

          public java.util.List<Task> getPlanningTargetsOf​(Task task)

    - #### getPlanningSourceOf

          public java.util.List<Task> getPlanningSourceOf​(Task task)

    - #### tryToStartPlanningTargets

          protected Changes tryToStartPlanningTargets​(Task task)

      Specified by:
        `tryToStartPlanningTargets` in class `TaskGroup`

    - #### startSubTasksIfPreconditionNotInProgress

          protected Changes startSubTasksIfPreconditionNotInProgress()

      Specified by:
        `startSubTasksIfPreconditionNotInProgress` in class `TaskGroup`

    - #### findLink

          public Link findLink​(java.lang.String linkId)